﻿<AML>
 <Item type="Method" id="77766C7A6EB344BCB079E771095CDEF5" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			acc_add_to_AP_create_new
Created By/Company:		SolidCAD 
Creation Date:			2018-01-23
Description:
	To show Selected Payable Invoice in Payment of details grid from Bill Received's Action 

	
Hooks:
	Type:	ItemType   : sop_sale_invoice
	Event:	Action(acc_ar_create_new)
	
Inputs:
	<describe the inputs expected by the server method>
	
Revisions:
	Rev Date		Modified By			Description
	2018-07-17		Chan			Can't do Payment for Bills that are not Base Currency.
	2018-07-20      Thin            skip 1 for acc_referenceno (AP100001 to AP100003), not comming 2
	2018-07-08      Chan            Customers should be same for selected invoices in Bill Received
	2019-02-19      Chan            ADMIN has no permission to do NEW PAYMENT. Should change message.
***************************************************************************** */
//debugger;

// method name - wo_CreatePOWithItems

if (!inArgs || !inArgs.results || !inArgs.results.getItemByIndex(0)) {
    return;
}

var check_permission;
var myInnovator = this.getInnovator();
var itemType = this.getType().toString().toLowerCase();

/*ADMIN has no permission to do NEW PAYMENT. Should change message*/
var ItemType = myInnovator.newItem("ItemType", "get");
ItemType.setAttribute("where", "ItemType.keyed_name='Acc_AccountPayable'");
var Can_Add = myInnovator.newItem("Can Add", "get");
var relitm = myInnovator.newItem("Identity", "get");
Can_Add.setRelatedItem(relitm);
ItemType.addRelationship(Can_Add);
ItemType = ItemType.apply();

if (ItemType.getItemCount() > 0)
{
    var result_Can_Add = ItemType.getRelationships("Can Add");
    for (var i = 0; i < result_Can_Add.getItemCount(); i++)
    {
        var each_result_Can_Add = result_Can_Add.getItemByIndex(i);
        var resultIdentity = each_result_Can_Add.getRelatedItem();
        var identityId = resultIdentity.getID();
        
        var Member = myInnovator.newItem("Member", "get");
        Member.setAttribute("select", "related_id");
        Member.setAttribute("where", "source_id='"+identityId+"'");
        Member = Member.apply();
        
        if (Member.getItemCount() > 0)
        {
            for (var j = 0; j < Member.getItemCount(); j++)
            {
                var each_result_Member = Member.getItemByIndex(j);
                var permission_userIdentity = each_result_Member.getProperty("related_id", "");
                var loginUserID = myInnovator.getUserID();
                
                // Start Get User Identity
                var alias = myInnovator.newItem("Alias", "get");
                alias.setProperty("source_id", loginUserID);
                alias.setPropertyCondition("source_id", "eq");
                alias = alias.apply();
                
                if (!alias.isError() && alias.getItemCount() > 0) {
                    var identity = myInnovator.getItemById("Identity", alias.getProperty("related_id", ""));
                    user_identity_id = identity.getID();
                }
                // End Get User Identity
                if(permission_userIdentity==user_identity_id)
                {
                    check_permission=1;
                    break;
                }
            }
        }
    }
}

/*ACC PURCHASE has no permission to do NEW PAYMENT. Should change message*/
if(check_permission==1)
{
    var erp_purchase_bank_account="";
    var erp_company_setup = myInnovator.newItem("erp_company_setup", "get");
    var result = erp_company_setup.apply();
    var result_count = result.getItemCount();
    if (result_count > 0) {
        var setup = result.getItemByIndex(0);
         erp_purchase_bank_account = setup.getProperty("erp_purchase_bank_account", "");
        
    }
    
    var acc_accountdetail_name="";
    var _acc_accountdetails_item = myInnovator.newItem("acc_accountdetails", "get");
    _acc_accountdetails_item.setProperty("id", erp_purchase_bank_account);
    _acc_accountdetails_item.setPropertyCondition("id", "eq");
    var _acc_accountdetails_item_result = _acc_accountdetails_item.apply();
    var acc_accountdetails_count = _acc_accountdetails_item_result.getItemCount();
    for (var j= 0; j < acc_accountdetails_count; j++) {
            _acc_accountdetails_item_result = _acc_accountdetails_item_result.getItemByIndex(j);
            acc_accountdetail_name = _acc_accountdetails_item_result.getProperty("acc_accountdetail_name", "");
    }
    
    var _acc_periods_item = myInnovator.newItem("acc_periods", "get");
    _acc_periods_item.setProperty("openingclsoingperiod", "0");
    _acc_periods_item.setPropertyCondition("openingclsoingperiod", "eq");
    var l_chk_result = _acc_periods_item.apply();
    var l_chk_count = l_chk_result.getItemCount();
    
    if (l_chk_count <= 0) {
      return  alert("You must create new accounting Periods for this transaction!");
    }
    else
    {
        for (var i = 0; i < l_chk_count; i++) 
        {
            l_chk_result = l_chk_result.getItemByIndex(i);
            var startperiod = l_chk_result.getProperty("startperiod", "");
            var local_startperiod=startperiod.substr(0, 10);
            
            var endperiod = l_chk_result.getProperty("endperiod", "");
            var local_endperiod=endperiod.substr(0, 10);
            
            var acc_journal_header = myInnovator.newItem("acc_journal_header", "get");
            acc_journal_header.setAttribute("select","acc_amount_currency");
            acc_journal_header.setProperty("acc_transactiontype", "Opening Balance");
            acc_journal_header.setPropertyCondition("acc_transactiontype", "eq");
            acc_journal_header.setProperty("acc_date", startperiod);
            acc_journal_header.setPropertyCondition("acc_date", "ge");
            acc_journal_header.setProperty("acc_date", endperiod);
            acc_journal_header.setPropertyCondition("acc_date", "le");
            acc_journal_header.setAttribute("orderBy", "acc_date asc ");
            var acc_journal_details = myInnovator.newItem("acc_journal_details", "get");
            acc_journal_details.setProperty("acc_accountid", erp_purchase_bank_account);
            acc_journal_details.setPropertyCondition("acc_accountid", "eq");
            acc_journal_header.addRelationship(acc_journal_details);
            var getOpeningBalanceData = acc_journal_header.apply();
            
            var opcount = getOpeningBalanceData.getItemCount();
            if (opcount <= 0) {
                return  alert("You must create opening balance for this bank account ( " + acc_accountdetail_name + " ) Between "+local_startperiod+" And "+local_endperiod+" of accounting period in journal!");
        
            }
            else
            {
                var diff_acc_payment = 0;
                var payment_details_count;
                var duplicate_id = "";
                var params = {};
                var acc_total_payment=0;
                var acc_total_payment_amount=0;
                params.pop_purchase_Items = inArgs.results;
                
                var newAP = myInnovator.newItem("Acc_AccountPayable", "add");

                var todayDate = new Date();
                todayDate.setDate(todayDate.getDate());
                
                newAP.setProperty("acc_form", itemType);//2018-07-17
                newAP.setProperty("acc_date", dateFormat(todayDate));
                
                var _acc_total_own = 0.0;
                var newAPId = newAP.getID();
                var newAPType = newAP.getType();
                var itemCount = params.pop_purchase_Items.getItemCount();
                var check_vendor="";
                
                /* Vendors should be same for selected invoices in Bill Received*/
                for (var k = 0; k < itemCount; k++) {
                    var part_item = myInnovator.newItem("", "");
                    part_item = inArgs.results.getItemByIndex(k);
                    var pop_vendor = part_item.getProperty("pop_vendor", "");
                    if(k===0)
                    {
                        check_vendor=pop_vendor;
                    }
                    if(check_vendor!==pop_vendor)
                    {
                        var message = myInnovator.newItem("variable", "get"); 
                        message.setProperty("name", "MSG_BillReceived_Vendor_Check");
                        var message_item = message.apply();
                        if (message_item.getItemCount() > 0 ) {
                            var message_value = message_item.getProperty("value", "");
                            return alert(message_value); 
                        }
                        
                    }
                }
                newAP.setProperty("acc_vendor", pop_vendor);
                /* Vendors should be same for selected invoices in Bill Received*/
                
                /*get Default Bank Account Start*/
                if (erp_purchase_bank_account !== "" ) 
                {
                    var acc_accountdetails_qry = myInnovator.newItem("acc_AccountDetails", "get");
                    acc_accountdetails_qry.setProperty("id", erp_purchase_bank_account);
                    var acc_accountdetails_qry_result = acc_accountdetails_qry.apply();
                    var acc_accountdetails_qry_count = acc_accountdetails_qry_result.getItemCount();
                    if (acc_accountdetails_qry_count > 0) 
                    {
                        var acc_accountdetails_result = acc_accountdetails_qry_result.getItemByIndex(0);
                        var id = acc_accountdetails_result.getProperty("id", "");
                        var acc_currency = acc_accountdetails_qry_result.getProperty("acc_currency", "");
                        var acc_amount = acc_accountdetails_qry_result.getProperty("acc_amount", "");
                       
                        newAP.setProperty("acc_cash_account",erp_purchase_bank_account)
                     
                      var currency_result=myInnovator.applyMethod("acc_currency_info","<currency_id>"+acc_currency+"</currency_id><currency_date>"+dateFormat(todayDate)+"</currency_date>");
                       
                        var currency_count = currency_result.getItemCount();
                        if (currency_count > 0) 
                        {
                            var currency_code = currency_result.getProperty("acc_currencycode", "");
                            newAP.setProperty("acc_currency",currency_result.getProperty("id", ""));
                            newAP.setProperty("acc_cash_balance",acc_amount);
                            newAP.setProperty("acc_rate",currency_result.getProperty("acc_monthly_rate", ""));
                            newAP.setProperty("acc_operator",currency_result.getProperty("acc_operator", ""));
                          
                            if(currency_result.getProperty("acc_isdefault", "") == "1")
                            {
                                newAP.setProperty("acc_currency_default",1);
                            }
                            else
                            {
                                newAP.setProperty("acc_currency_default",0);
                            }
                        }
                    }
                }
                /*get Default Bank Account End*/
                
                for (var k = 0; k < itemCount; k++) 
                {
                    var part_item = myInnovator.newItem("", "");
                    part_item = inArgs.results.getItemByIndex(k);
                
                    var pop_id = part_item.getProperty("id", "");
                    var pop_invoice_no = part_item.getProperty("pop_invoice_no", "");
                    var pop_vendor = part_item.getProperty("pop_vendor", "");
                    var pop_invoice_date = part_item.getProperty("pop_invoice_date", "");
                    var pop_invoice_status = part_item.getProperty("pop_invoice_status", "");
                    var oneDay = 24*60*60*1000; // hours*minutes*seconds*milliseconds
                    var invoiceDate = new Date(pop_invoice_date);
                    var todayDate = new Date( );
                    var diffDays = Math.round(Math.abs((todayDate.getTime() - invoiceDate.getTime()) / (oneDay)));
                    var acc_thirty=">30 days";
                    var acc_fortyfive=">45 days";
                    var acc_sixty=">60 days";
                    var acc_ninty=">90 days";
                                    
                    var pop_total_amount = part_item.getProperty("pop_total_amount", "");
                    var acc_puramount=parseFloat(pop_total_amount);
                    var pop_own_amount = part_item.getProperty("pop_own_amount", "");
                    var pop_paying = part_item.getProperty("pop_paying", "");
                   //Check payment if create new payment
                
                     var acc_account_payable = myInnovator.newItem("Acc_AccountPayable", "get");
                     var acc_account_payable_items = acc_account_payable.apply();
                     var payment_count = acc_account_payable_items.getItemCount();
                
                     for (i = 0; i < payment_count; i++) 
                     {
                
                        var acc_account_payable_item = acc_account_payable_items.getItemByIndex(i);
                        var payment_id = acc_account_payable_item.getProperty("id", "");
                        var test_count = acc_account_payable_item.getItemCount();
                         
                        var payable = myInnovator.newItem("Acc_AccountPayable_Detail", "get"); 
                        payable.setProperty("SOURCE_ID", payment_id);
                		payable.setPropertyCondition("SOURCE_ID", "eq");
                        var gRelationships_data = payable.apply();
                        var itemCountdetails = gRelationships_data.getItemCount();
                        if (itemCountdetails > 0 ) 
                        {
                             for (var j = 0; j < itemCountdetails; j++) 
                             {
                
                                var payment_details_item = gRelationships_data.getItemByIndex(j);
                                var payment_details_id = payment_details_item.getProperty("acc_purchaseid", "");
                
                                if (payment_details_id === pop_id) 
                                {
                                        if (duplicate_id === null || duplicate_id === "") 
                                        {
                                            duplicate_id = payment_details_id;
                                            
                                            var check_payable = myInnovator.newItem("Acc_AccountPayable_Detail", "get"); 
                                            check_payable.setProperty("acc_purchaseid", pop_id);
                                    		check_payable.setPropertyCondition("acc_purchaseid", "eq");
                                            var payment_details_data = check_payable.apply();
                                            payment_details_count = payment_details_data.getItemCount();
                                            if (payment_details_count > 0 ) 
                                            {
                                                 for (var g = 0; g < payment_details_count; g++) 
                                                 {
                                                    var payment_details_data_item = payment_details_data.getItemByIndex(g);
                    
                                                    var acc_payment = payment_details_data_item.getProperty("acc_payment", "");
                                                    var f_acc_payment = parseFloat(acc_payment);
                    
                                                    diff_acc_payment = pop_total_amount - f_acc_payment;
                                                    pop_total_amount = diff_acc_payment;
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        payment_details_count="";
                                    }
                                }
                            }
                        }
                        if (payment_details_count === undefined || payment_details_count==="") 
                        {
                            diff_acc_payment = pop_total_amount;
                        }
                        if(pop_own_amount > 0 )
                        {
                            pop_total_amount = parseFloat(pop_total_amount);
                            if (isNaN(pop_paying)) {
                                pop_paying = 0;
                            }
                            _acc_total_own = parseFloat(_acc_total_own) + parseFloat(pop_own_amount);
                            var _ref_id = part_item.getProperty("id", "");
                            
                            if (pop_invoice_status !== "PAID" && pop_invoice_status !== "Created" && pop_invoice_status !== "Approved") 
                            {
                        
                                var relationshipItem = myInnovator.newItem("Acc_AccountPayable_Detail", "add");
                                relationshipItem.setProperty("acc_pay_check",1);
                                relationshipItem.setPropertyItem("acc_purchaseid", part_item);
                                relationshipItem.setProperty("acc_invoiceno", pop_invoice_no);
                                relationshipItem.setProperty("acc_date", pop_invoice_date);
                                var currency_item = myInnovator.newItem("acc_Currency", "get");
                                currency_item.setProperty("id", part_item.getProperty("pop_currency", ""));
                                currency_item.setPropertyCondition("id", "eq");
                                currency_item = currency_item.apply();
                                relationshipItem.setPropertyItem("acc_pop_currency", currency_item);
                                relationshipItem.setProperty("acc_amount", acc_puramount);
                                var bank_item = myInnovator.newItem("acc_AccountDetails", "get");
                                bank_item.setProperty("id", erp_purchase_bank_account);
                                bank_item.setPropertyCondition("id", "eq");
                                bank_item = bank_item.apply();
                                if(bank_item.getItemCount()>0)
                                {
                                    relationshipItem.setPropertyItem("acc_ap_cashbook",bank_item);
                                }
                                if (diffDays > 30 && diffDays <= 45) 
                                {
                                   relationshipItem.setProperty("acc_info_date",acc_thirty);
                                }
                                if (diffDays > 45 && diffDays <= 60)
                                {
                                    relationshipItem.setProperty("acc_info_date",acc_fortyfive);
                                }
                                else if (diffDays > 60 && diffDays <= 90)
                                {
                                     relationshipItem.setProperty("acc_info_date",acc_sixty);
                                }
                                else if (diffDays > 90)
                                {
                                     relationshipItem.setProperty("acc_info_date",acc_ninty);
                                }
                                relationshipItem.setPropertyItem("acc_ap_currency",currency_item);
                                relationshipItem.setProperty("acc_exchange_amount",pop_total_amount);
                                relationshipItem.setProperty("acc_exchange_ownamount",pop_own_amount);
                                relationshipItem.setProperty("acc_payment", pop_total_amount);
                                relationshipItem.setProperty("acc_owing", pop_total_amount);
                                var vendor_item = myInnovator.newItem("Vendor", "get");
                                vendor_item.setProperty("id",pop_vendor);
                                vendor_item.setPropertyCondition("id", "eq");
                                vendor_item  = vendor_item.apply();
                                if(vendor_item.getItemCount()>0)
                                {
                                relationshipItem.setPropertyItem("acc_vendor", vendor_item);
                                }
                                var source_id = newAPId;
                                relationshipItem.setProperty("source_id", source_id);
                    
                                newAP.addRelationship(relationshipItem);
                            }
                        }
                        if (diff_acc_payment === 0)
                        { 
                            return alert("Payment finished for this "+pop_invoice_no+" invoice.");
                        }
                     
                        if (pop_invoice_status === "PAID" || pop_invoice_status === "Created" || pop_invoice_status === "Approved") 
                        {
                             
                            return alert('Need to promote.This item is not "Post To GL".');
                        }
                        acc_total_payment+=parseFloat(pop_total_amount, 10);
                        acc_total_payment_amount+=parseFloat(pop_total_amount, 10);
                        duplicate_id="";
                }
                var ap_details_result = newAP.apply();
                if (ap_details_result.isError()) 
                {
                    alert(ap_details_result.getErrorDetail());
                }
                var ap_edit = myInnovator.newItem("Acc_AccountPayable", "edit");
                ap_edit.setAttribute("where", "id='" + newAPId + "'");
                ap_edit.setProperty("acc_total_payment",acc_total_payment);
                ap_edit.setProperty("acc_total_payment_amount",acc_total_payment_amount);
                ap_edit.setProperty("acc_is_bulk_payment", "1");
                ap_edit = ap_edit.apply();
                newAP.LockItem();
                top.aras.uiShowItem(newAPType, newAPId);
            }
        }
    }
}
else
{
   alert("You have insufficient permissions to perform this operation."); 
}
function dateFormat(d) {
    var dateString = d.getFullYear() + "-";
    dateString += pad(d.getMonth() + 1) + "-";
    dateString += pad(d.getDate()) + "T";
    dateString += pad(d.getHours()) + ":";
    dateString += pad(d.getMinutes()) + ":";
    dateString += pad(d.getSeconds());
    return dateString;
}

function pad(x) {
    return (x < 10) ? "0" + x : "" + x;
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>acc_add_to_AP_create_new</name>
 </Item>
</AML>